Merge remote-tracking branch 'origin/pr/259'
[grml-debootstrap.git] / chroot-script
1 #!/bin/bash
2 # Filename:      /etc/debootstrap/chroot-script
3 # Purpose:       script executed in chroot when installing Debian via grml-debootstrap
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8 # GRML_CHROOT_SCRIPT_MARKER - do not remove this line unless you want to keep
9 # this script as /bin/chroot-script on your new installed system
10 ################################################################################
11 # shellcheck disable=SC2317  # shellcheck has trouble understanding the code flow in this file
12
13 # error_handler {{{
14 set -e
15 set -E
16 set -o pipefail
17 trap "error_handler" ERR
18 # }}}
19
20 bash -n /etc/debootstrap/config
21 # shellcheck source=config
22 . /etc/debootstrap/config    || exit 1
23 bash -n /etc/debootstrap/variables
24 # shellcheck source=tests/shellcheck-stub-debootstrap-variables
25 . /etc/debootstrap/variables || exit 1
26
27 [ -r /proc/1 ] || mount -t proc none /proc
28 [ -r /sys/kernel ] || mount -t sysfs none /sys
29
30 # variable checks {{{
31
32 # use aptitude only if it's available
33 if [ -x /usr/bin/aptitude ] ; then
34    APTUPDATE="aptitude update $DPKG_OPTIONS"
35    # Debian ISOs do not contain signed Release files
36    if [ -n "$ISO" ] ; then
37       APTINSTALL="aptitude -y --allow-untrusted --without-recommends install $DPKG_OPTIONS"
38       APTUPGRADE="aptitude -y --allow-untrusted safe-upgrade $DPKG_OPTIONS"
39    else
40       APTINSTALL="aptitude -y --without-recommends install $DPKG_OPTIONS"
41       APTUPGRADE="aptitude -y safe-upgrade $DPKG_OPTIONS"
42    fi
43 else
44    APTINSTALL="apt-get -y --no-install-recommends install $DPKG_OPTIONS"
45    APTUPDATE="apt-get update $DPKG_OPTIONS"
46    APTUPGRADE="apt-get -y upgrade $DPKG_OPTIONS"
47 fi
48
49 if [ -z "$STAGES" ] ; then
50    STAGES='/etc/debootstrap/stages'
51    [ -d "$STAGES" ] || mkdir -p "$STAGES"
52 fi
53 # }}}
54
55 # helper functions {{{
56 stage() {
57   if [ -n "$2" ] ; then
58      echo "$2" > "$STAGES/$1"
59      return 0
60   elif grep -q 'done' "$STAGES/$1" 2>/dev/null ; then
61      echo "   [*] Notice: stage $1 has been executed already, skipping execution therefore.">&2
62      return 1
63   fi
64   echo "   Executing stage ${1}"
65   return 0
66 }
67
68 askpass() {
69   # read -s emulation for dash. result is in $resp.
70   set -o noglob
71   [ -t 0 ] && stty -echo
72   read -r resp
73   [ -t 0 ] && stty echo
74   set +o noglob
75 }
76 # }}}
77
78 # define chroot mirror {{{
79 chrootmirror() {
80   if [ "$KEEP_SRC_LIST" = "yes" ] ; then
81     echo "KEEP_SRC_LIST has been enabled, skipping chrootmirror stage."
82     return
83   fi
84
85   if [ -z "$COMPONENTS" ] ; then
86     COMPONENTS='main'
87   fi
88   echo "Using repository components $COMPONENTS"
89
90   if [ -n "$ISO" ] ; then
91     echo "Adjusting sources.list for ISO (${ISO})."
92     echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
93
94     if [ -n "$MIRROR" ] ; then
95       echo "Adding mirror entry (${MIRROR}) to sources.list."
96       echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
97     fi
98   else
99     if [ -n "$MIRROR" ] ; then
100       echo "Adjusting sources.list for mirror (${MIRROR})."
101       echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
102     fi
103   fi
104
105   # add security.debian.org:
106   case "$RELEASE" in
107     unstable|sid|stretch) ;;  # no security pool available
108     jessie|buster)
109       echo "Adding security.debian.org to sources.list."
110       echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
111       ;;
112     *)
113       # bullseye and newer releases use a different repository layout, see
114       # https://lists.debian.org/debian-devel-announce/2019/07/msg00004.html
115       echo "Adding security.debian.org/debian-security to sources.list."
116       echo "deb http://security.debian.org/debian-security ${RELEASE}-security $COMPONENTS" >> /etc/apt/sources.list
117       ;;
118   esac
119 }
120 # }}}
121
122 # remove local chroot mirror {{{
123 remove_chrootmirror() {
124   if [ "$KEEP_SRC_LIST" = "yes" ] ; then
125     echo "KEEP_SRC_LIST has been enabled, skipping remove_chrootmirror stage."
126     return
127   fi
128
129   if [ -n "$ISO" ] ; then
130     echo "Removing ISO (${ISO}) from sources.list."
131     TMP_ISO="${ISO//\//\\\/}"
132     sed -i "/deb $TMP_ISO $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
133   else
134     if [ -n "$MIRROR" ] && echo "$MIRROR" | grep -q 'file:' ; then
135       echo "Removing local mirror (${MIRROR}) from sources.list."
136       TMP_MIRROR="${MIRROR//\//\\\/}"
137       sed -i "/deb $TMP_MIRROR $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
138       echo "Adding fallback mirror entry (${FALLBACK_MIRROR}) to sources.list instead."
139       echo "deb $FALLBACK_MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
140     fi
141   fi
142 }
143 # }}}
144
145 # set up grml repository {{{
146 grmlrepos() {
147   if [ -z "$GRMLREPOS" ] ; then
148     return 0
149   fi
150
151   # user might have provided their own apt sources configuration
152   if [ -r /etc/apt/sources.list.d/grml.list ] ; then
153     echo "File /etc/apt/sources.list.d/grml.list exists already, not modifying."
154   else
155     echo "Setting up /etc/apt/sources.list.d/grml.list."
156     cat > /etc/apt/sources.list.d/grml.list << EOF
157 # grml: stable repository:
158   deb     [signed-by=/usr/share/keyrings/grml-archive-keyring.gpg] http://deb.grml.org/ grml-stable main
159   deb-src [signed-by=/usr/share/keyrings/grml-archive-keyring.gpg] http://deb.grml.org/ grml-stable main
160
161 # grml: testing/development repository:
162   deb     [signed-by=/usr/share/keyrings/grml-archive-keyring.gpg] http://deb.grml.org/ grml-testing main
163   deb-src [signed-by=/usr/share/keyrings/grml-archive-keyring.gpg] http://deb.grml.org/ grml-testing main
164 EOF
165   fi
166
167   # make sure we install packages from Grml's pool only if not available from Debian
168   if [ -r /etc/apt/preferences.d/grml.pref ] ; then
169     echo "File /etc/apt/preferences.d/grml.pref exists already, not modifying."
170   else
171     echo "Setting up /etc/apt/preferences.d/grml.pref."
172     cat > /etc/apt/preferences.d/grml.pref << EOF
173 Explanation: use Grml repository only after Debian ones
174 Package: *
175 Pin: origin deb.grml.org
176 Pin-Priority: 100
177 EOF
178   fi
179
180   apt-get update -o Acquire::AllowInsecureRepositories=1
181   apt-get -y --allow-unauthenticated install grml-debian-keyring
182   apt-get update
183
184   if [ "$(dpkg-query -f "\${db:Status-Status} \${db:Status-Eflag}" -W grml-debian-keyring 2>/dev/null)" != 'installed ok' ]; then
185     echo "Error: installation of grml-debian-keyring failed." >&2
186     exit 1
187   fi
188 }
189 # }}}
190
191 # feature to provide Debian backports repos {{{
192 backportrepos() {
193   if [ -n "$BACKPORTREPOS" ] ; then
194     cat >> /etc/apt/sources.list.d/backports.list << EOF
195 # debian backports: ${RELEASE}-backports repository:
196 deb     ${MIRROR} ${RELEASE}-backports main
197 deb-src ${MIRROR} ${RELEASE}-backports main
198 EOF
199   fi
200 }
201 # }}}
202
203 # set up kernel-img.conf {{{
204 kernelimg_conf() {
205   if ! [ -r /etc/kernel-img.conf ] ; then
206      echo "Setting up /etc/kernel-img.conf"
207      cat > /etc/kernel-img.conf << EOF
208 # Kernel Image management overrides
209 # See kernel-img.conf(5) for details
210 do_initrd = Yes
211 do_symlinks = Yes
212 EOF
213   fi
214 }
215 # }}}
216
217 # make sure services do not start up {{{
218 install_policy_rcd() {
219   if ! [ -r /usr/sbin/policy-rc.d ] ; then
220      export POLICYRCD=1
221      cat > /usr/sbin/policy-rc.d << EOF
222 #!/bin/sh
223 exit 101
224 EOF
225      chmod 775 /usr/sbin/policy-rc.d
226   fi
227 }
228 # }}}
229
230 # make sure we have an up2date system {{{
231 upgrade_system() {
232   if [ "$UPGRADE_SYSTEM" = "yes" ] ; then
233     echo "Running update + upgrade"
234     $APTUPDATE
235     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTUPGRADE
236   else
237     echo "Not running update + upgrade as \$UPDATE_AND_UPGRADE is not set to 'yes'."
238   fi
239 }
240
241 # }}}
242 # remove now useless apt cache {{{
243 remove_apt_cache() {
244   if [ "$RM_APTCACHE" = 'yes' ] ; then
245     echo "Cleaning apt cache."
246     # shellcheck disable=SC2086
247     apt-get clean $DPKG_OPTIONS
248   else
249     echo "Not cleaning apt cache as \$RM_APTCACHE is unset."
250   fi
251 }
252 # }}}
253
254 # install additional packages {{{
255 packages() {
256   # Pre-seed the debconf database with answers. Each question will be marked
257   # as seen to prevent debconf from asking the question interactively.
258   [ -f /etc/debootstrap/debconf-selections ] && {
259     echo "Preseeding the debconf database, some lines might be skipped..."
260     debconf-set-selections < /etc/debootstrap/debconf-selections
261   }
262
263   if [ "$PACKAGES" = 'yes' ] ; then
264     PACKAGES_FILE="/etc/debootstrap/packages"
265
266     if [ "$ARCH" = 'arm64' ]; then
267       PACKAGES_FILE="/etc/debootstrap/packages-arm64"
268     fi
269
270     if ! [ -r "${PACKAGES_FILE}" ] ; then
271       echo "Error: ${PACKAGES_FILE} (inside chroot) not found, exiting." >&2
272       exit 1
273     else
274       $APTUPDATE
275
276       # shellcheck disable=SC2086,SC2046
277       DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $(grep -v '^#' "${PACKAGES_FILE}") $GRMLPACKAGES
278     fi
279   fi
280 }
281 # }}}
282
283 # install extra packages {{{
284 extrapackages() {
285     if [ "$EXTRAPACKAGES" = 'yes' ] ; then
286         PACKAGELIST=$(find /etc/debootstrap/extrapackages -type f -name '*.deb')
287         if [ -n "$PACKAGELIST" ]; then
288             # shellcheck disable=SC2086
289             dpkg -i $PACKAGELIST
290             # run apt again to resolve any deps
291             DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL
292         fi
293     fi
294 }
295 # }}}
296
297 # check if the specified Debian package exists
298 package_exists() {
299   output=$(apt-cache show "$1" 2>/dev/null)
300   [ -n "$output" ]
301   return $?
302 }
303
304
305 # determine the kernel version postfix
306 get_kernel_version() {
307   # do not override $KERNEL if set via config file
308   if [ -n "$KERNEL" ] ; then
309     echo "$KERNEL"
310     return 0
311   fi
312
313   local KARCH
314
315   # shellcheck disable=SC2153
316   case "$ARCH" in
317     i386)
318       KARCH='686-pae'
319       ;;
320     amd64)
321       KARCH='amd64'
322       ;;
323     arm64)
324       KARCH='arm64'
325       ;;
326     *)
327       echo "Only i386, amd64 and arm64 are currently supported" >&2
328       return 1
329   esac
330
331   local KPACKAGE
332   KPACKAGE=linux-image-"${KPREFIX}${KARCH}"
333   if package_exists "$KPACKAGE"; then
334     echo "${KPREFIX}${KARCH}"
335     return 0
336   fi
337
338   echo "Expected kernel package $KPACKAGE not found" >&2
339   return 1
340 }
341
342 # install kernel packages {{{
343 kernel() {
344   if [ -n "$NOKERNEL" ] ; then
345     echo "Skipping installation of kernel packages as requested via --nokernel"
346     return 0
347   fi
348
349   $APTUPDATE
350   KVER=$(get_kernel_version)
351   if [ -n "$KVER" ] ; then
352      KERNELPACKAGES="linux-image-$KVER linux-headers-$KVER firmware-linux-free $INITRD_GENERATOR"
353      # only add firmware-linux if we have non-free as a component
354      if expr "$COMPONENTS" : '.*non-free' >/dev/null ; then
355        KERNELPACKAGES="$KERNELPACKAGES firmware-linux"
356      fi
357      # shellcheck disable=SC2086
358      DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $KERNELPACKAGES
359   else
360      echo "Warning: Could not find a kernel for your system. Your system won't be able to boot itself!"
361   fi
362 }
363 # }}}
364
365 # reconfigure packages {{{
366 reconfigure() {
367   if [ -n "$RECONFIGURE" ] ; then
368      for package in $RECONFIGURE ; do
369          if dpkg --list "$package" >/dev/null 2>&1 | grep -q '^ii' ; then
370            DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure "$package" || \
371            echo "Warning: $package does not exist, can not reconfigure it."
372          fi
373      done
374   fi
375 }
376 # }}}
377
378 # set password of user root {{{
379 passwords()
380 {
381   if [ -n "$NOPASSWORD" ] ; then
382     echo "Skip setting root password as requested."
383     return 0
384   fi
385
386   CHPASSWD_OPTION=
387   if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
388      CHPASSWD_OPTION='-m'
389   fi
390
391   if [ -n "$ROOTPASSWORD" ] ; then
392      # shellcheck disable=SC2086
393      echo root:"$ROOTPASSWORD" | chpasswd $CHPASSWD_OPTION
394      export ROOTPASSWORD=''
395   else
396     a='1'
397     b='2'
398      echo "Setting password for user root:"
399      while [ "$a" != "$b" ] ; do
400        printf "Enter new UNIX password for user root: "
401        askpass
402        a="$resp"
403        unset resp
404        echo
405        printf "Retype new UNIX password for user root: "
406        askpass
407        b="$resp"
408        unset resp
409        echo
410        if [ "$a" != "$b" ] ; then
411          echo "Sorry, passwords do not match. Retry."
412          a='1'
413          b='2'
414        else
415          # shellcheck disable=SC2086
416          echo root:"$a" | chpasswd $CHPASSWD_OPTION
417          unset a
418          unset b
419        fi
420      done
421   fi
422 }
423 # }}}
424
425 # set up /etc/hosts {{{
426 hosts() {
427   if ! [ -f /etc/hosts ] ; then
428      cat > /etc/hosts << EOF
429 127.0.0.1       localhost
430 ::1             localhost ip6-localhost ip6-loopback
431 ff02::1         ip6-allnodes
432 ff02::2         ip6-allrouters
433 EOF
434   fi
435 }
436 # }}}
437
438 # set default locales {{{
439 default_locales() {
440   if [ -n "$DEFAULT_LOCALES" ] ; then
441     if ! [ -x /usr/sbin/update-locale ] ; then
442       echo "Warning: update-locale executable not available (no locales package installed?)"
443       echo "Ignoring request to run update-locale for $DEFAULT_LOCALES therefore"
444       return 0
445     fi
446
447     /usr/sbin/update-locale LANGUAGE="$DEFAULT_LANGUAGE" LANG="$DEFAULT_LOCALES"
448   fi
449 }
450 # }}}
451
452 # adjust timezone {{{
453 timezone() {
454   if [ -n "$TIMEZONE" ] ; then
455     echo "Adjusting /etc/localtime"
456     ln -sf "/usr/share/zoneinfo/$TIMEZONE" /etc/localtime
457
458     echo "Setting /etc/timezone to $TIMEZONE"
459     printf '%s\n' "$TIMEZONE"  > /etc/timezone
460
461   fi
462 }
463 # }}}
464
465 # helper function for fstab() {{{
466 createfstab(){
467   echo "Setting up /etc/fstab"
468   cat > /etc/fstab <<EOF
469 # /etc/fstab - created by grml-debootstrap on $(date)
470 # Accessible filesystems, by reference, are maintained under '/dev/disk/'.
471 # See man pages fstab(5), findfs(8), mount(8) and/or blkid(8) for more info.
472 #
473 # After editing this file, run 'systemctl daemon-reload' to update systemd
474 # units generated from this file.
475 #
476 EOF
477
478   if [ -n "$TARGET_UUID" ] ; then
479     local rootfs_mount_options=""
480
481     if [ -z "${FILESYSTEM}" ] ; then
482       FILESYSTEM="$(blkid -o value -s TYPE /dev/disk/by-uuid/"${TARGET_UUID}")" || true
483     fi
484
485     case "${FILESYSTEM}" in
486       # errors=remount-ro is supported only by a few file systems
487       ext*|exfat|fat|jfs|nilfs2|vfat)
488         rootfs_mount_options=",errors=remount-ro"
489         ;;
490     esac
491
492     echo "/dev/disk/by-uuid/${TARGET_UUID} /  auto    defaults${rootfs_mount_options} 0   1" >> /etc/fstab
493   else
494     echo "Warning: couldn't identify target UUID for rootfs, your /etc/fstab might be incomplete."
495   fi
496
497 if [ -n "$EFI" ] ; then
498   UUID_EFI="$(blkid -o value -s UUID "$EFI")"
499   echo "UUID=$UUID_EFI  /boot/efi       vfat    umask=0077      0       1" >> /etc/fstab
500 fi
501
502 cat >> /etc/fstab << EOF
503 proc           /proc        proc    defaults                      0   0
504 /dev/cdrom     /mnt/cdrom0  iso9660 ro,user,noauto                0   0
505 # some other examples:
506 # /dev/sda2       none         swap    sw,pri=0             0   0
507 # /dev/hda1       /Grml        ext3    dev,suid,user,noauto 0  2
508 # //1.2.3.4/pub   /smb/pub     cifs    user,noauto,uid=grml,gid=grml 0 0
509 # linux:/pub      /beer        nfs     defaults             0  0
510 # tmpfs           /tmp         tmpfs   size=300M            0  0
511 # /dev/sda5       none         swap    sw                   0  0
512 EOF
513 }
514 # }}}
515
516 # generate /etc/fstab {{{
517 fstab() {
518   # set up /etc/fstab if file is not present (cdebootstrap)
519   if [ ! -f /etc/fstab  ] ; then
520      createfstab
521   fi
522
523   # set up /etc/fstab if file is UNCONFIGURED (debootstrap)
524   if grep -q UNCONFIGURED /etc/fstab ; then
525      createfstab
526   fi
527 }
528 # }}}
529
530 # ensure we have according filesystem tools available {{{
531 install_fs_tools() {
532   local pkg=""
533
534   # note: this is supposed to be coming either via command lines'
535   # $_opt_filesystem or via createfstab()
536   case "${FILESYSTEM}" in
537     jfs)
538       pkg="jfsutils"
539       ;;
540     xfs)
541       pkg="xfsprogs"
542       ;;
543   esac
544
545   if [ -n "${pkg:-}" ] && ! dpkg --list "${pkg}" 2>/dev/null | grep -q '^ii' ; then
546     echo "Filesystem package ${pkg} not present, installing now"
547     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL "${pkg}"
548   fi
549 }
550 # }}}
551
552 # set up hostname {{{
553 hostname() {
554   if [ -n "$HOSTNAME" ] ; then
555      echo "Setting hostname to ${HOSTNAME}."
556      echo "$HOSTNAME" > /etc/hostname
557
558      # adjust postfix configuration
559      if [ -r /etc/postfix/main.cf ] ; then
560         # adjust hostname related options:
561         sed -i "s/grml/$HOSTNAME/g" /etc/postfix/main.cf
562
563         # listen on loopback interface only:
564         sed -i "s/^inet_interfaces = .*/inet_interfaces = loopback-only/" /etc/postfix/main.cf
565         grep -q inet_interfaces /etc/postfix/main.cf || echo 'inet_interfaces = loopback-only' >> /etc/postfix/main.cf
566      fi
567      if [ -r /etc/mailname ] ; then
568         # adjust /etc/mailname
569         local etc_mail_domain
570         etc_mail_domain=$(/bin/dnsdomainname 2>/dev/null || echo localdomain)
571         case "$HOSTNAME" in
572           *.*)
573             local mailname="$HOSTNAME"
574             ;;
575           *)
576             local mailname="${HOSTNAME}.${etc_mail_domain}"
577             ;;
578         esac
579         echo "Setting mailname to ${mailname}"
580         echo "$mailname" > /etc/mailname
581      fi
582   fi
583 }
584 # }}}
585
586 # generate initrd/initramfs {{{
587 initrd() {
588   # assume the first available kernel as our main kernel
589   # shellcheck disable=SC2012
590   KERNELIMG=$(ls -1 /boot/vmlinuz-* 2>/dev/null | head -1)
591   if [ -z "$KERNELIMG" ] ; then
592      echo 'No kernel image found, skipping initrd stuff.'>&2
593      return
594   fi
595
596   KERNELVER=${KERNELIMG#/boot/vmlinuz-}
597
598   # generate initrd
599   if [ -n "$INITRD" ] ; then
600      echo "Generating initrd."
601      if [ "$INITRD_GENERATOR" = 'dracut' ] ; then
602          # shellcheck disable=SC2086
603          dracut --no-hostonly --kver "$KERNELVER" --fstab --add-fstab /etc/fstab --force --reproducible $INITRD_GENERATOR_OPTS
604      else
605          # shellcheck disable=SC2086
606          update-initramfs -c -t -k "$KERNELVER" $INITRD_GENERATOR_OPTS
607      fi
608   fi
609 }
610 # }}}
611
612 efi_setup() {
613   if [ -z "$EFI" ] ; then
614     return 0
615   fi
616
617   if ! dpkg --list efibootmgr 2>/dev/null | grep -q '^ii' ; then
618     echo "Notice: efi option set but no efibootmgr package, installing it therefore."
619     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL efibootmgr
620   fi
621
622   mkdir -p /boot/efi
623   echo "Mounting $EFI on /boot/efi"
624   mount "$EFI" /boot/efi
625
626   # if efivarfs kernel module is loaded, but efivars isn't,
627   # then we need to mount efivarfs for efibootmgr usage
628   if ! ls /sys/firmware/efi/efivars/* &>/dev/null ; then
629     echo "Mounting efivarfs on /sys/firmware/efi/efivars"
630     mount -t efivarfs efivarfs /sys/firmware/efi/efivars
631   fi
632
633   echo "Invoking efibootmgr"
634   efibootmgr
635 }
636
637 # grub configuration/installation {{{
638
639 # helper function to get relevant /dev/disk/by-id/* entries,
640 # based on GRUB's postinst script
641 available_ids() {
642   local path ids
643
644   [ -d /dev/disk/by-id ] || return
645   ids="$(
646     for path in /dev/disk/by-id/*; do
647       [ -e "${path}" ] || continue
648       printf '%s %s\n' "${path}" "$(readlink -f "${path}")"
649     done | sort -k2 -s -u | cut -d' ' -f1
650   )"
651   echo "${ids}"
652 }
653
654 # helper function to report corresponding /dev/disk/by-id/ for a given device name,
655 # based on GRUB's postinst script
656 device_to_id() {
657   local id
658
659   for id in $(available_ids); do
660     if [ "$(readlink -f "${id}")" = "$(readlink -f "$1")" ]; then
661       echo "${id}"
662       return 0
663     fi
664   done
665
666   # Fall back to the plain device name if there's no by-id link for it.
667   if [ -e "$1" ]; then
668     echo "$1"
669     return 0
670   fi
671   return 1
672 }
673
674 grub_install() {
675
676   if [ -z "$GRUB" ] ; then
677     echo "Notice: \$GRUB not defined, will not install grub inside chroot at this stage."
678     return 0
679   fi
680
681   efi_setup
682
683   if [ -n "$EFI" ] ; then
684     GRUB_PACKAGE=grub-efi-amd64
685   else
686     GRUB_PACKAGE=grub-pc
687   fi
688
689   # make sure this is pre-defined so we have sane settings for automated
690   # upgrades, see https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=711019
691   local grub_device
692   grub_device=$(device_to_id "${GRUB}")
693   if [ -z "${grub_device:-}" ] ; then
694      echo "Warning: Could not identify /dev/disk/by-id/... for '${GRUB}', falling back to '${GRUB}'"
695      grub_device="${GRUB}"
696   fi
697
698   echo "Setting ${GRUB_PACKAGE} debconf configuration for install device to $GRUB"
699   echo "${GRUB_PACKAGE} ${GRUB_PACKAGE}/install_devices multiselect ${grub_device}" | debconf-set-selections
700
701   if ! dpkg --list "${GRUB_PACKAGE}" 2>/dev/null | grep -q '^ii' ; then
702     echo "Notice: grub option set but no ${GRUB_PACKAGE} package, installing it therefore."
703     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL "${GRUB_PACKAGE}"
704   fi
705
706   if ! [ -x "$(command -v grub-install)" ] ; then
707      echo "Error: grub-install not available. (Error while installing grub package?)" >&2
708      return 1
709   fi
710   if ! [ -x "$(command -v update-grub)" ] ; then
711      echo "Error: update-grub not available. (Error while installing grub package?)" >&2
712      return 1
713   fi
714
715   if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
716      for device in $SELECTED_PARTITIONS ; do
717         GRUB="${device%%[0-9]}"
718         echo "Installing grub on ${GRUB}:"
719         if ! grub-install --no-floppy "$GRUB" ; then
720           echo "Error: failed to execute 'grub-install --no-floppy $GRUB'." >&2
721           exit 1
722         fi
723
724      done
725      rm -f /boot/grub/device.map
726   else
727     echo "Installing grub on ${GRUB}:"
728     echo "(hd0) ${GRUB}" > /boot/grub/device.map
729     if ! grub-install "(hd0)" ; then
730       echo "Error: failed to execute 'grub-install (hd0)'." >&2
731       exit 1
732     fi
733     rm /boot/grub/device.map
734   fi
735
736   echo "Adjusting grub configuration for use on ${GRUB}."
737
738   if [ -n "${BOOT_APPEND}" ] ; then
739     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
740     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" /etc/default/grub
741   fi
742
743   mountpoint /boot/efi &>/dev/null && umount /boot/efi
744
745   # finally install grub. Existence of update-grub is checked above.
746   update-grub
747 }
748 # }}}
749
750 # execute all scripts present in /etc/debootstrap/chroot-scripts/ {{{
751 custom_scripts() {
752   [ -d /etc/debootstrap/chroot-scripts/ ] || return 0
753
754   for script in /etc/debootstrap/chroot-scripts/* ; do
755       echo "Executing script $script"
756       $script && echo "done" || echo "failed"
757   done
758 }
759 # }}}
760
761 # make sure we don't have any running processes left {{{
762 services() {
763   for service in ssh mdadm mdadm-raid ; do
764     if [ -x /etc/init.d/"$service" ] ; then
765        /etc/init.d/"$service" stop || true
766     fi
767   done
768 }
769 # }}}
770
771 # unmount /proc and make sure nothing is left {{{
772 finalize() {
773   # make sure we don't leave any sensible data
774   rm -f /etc/debootstrap/variables
775
776   [ -n "$POLICYRCD" ] && rm -f /usr/sbin/policy-rc.d
777
778   umount /sys/firmware/efi/efivars &>/dev/null || true
779
780   umount /sys >/dev/null 2>/dev/null || true
781   umount /proc >/dev/null 2>/dev/null || true
782 }
783 # }}}
784
785 # signal handler {{{
786 signal_handler() {
787   finalize
788   [ -n "$1" ] && EXIT="$1" || EXIT="1"
789   exit "$EXIT"
790 }
791 # }}}
792
793 # set signal handler {{{
794 trap signal_handler HUP INT QUIT TERM
795 # }}}
796
797 # execute the functions {{{
798
799  # always execute install_policy_rcd
800  install_policy_rcd
801
802  for i in chrootmirror grmlrepos backportrepos kernelimg_conf \
803      kernel packages extrapackages reconfigure hosts \
804      default_locales timezone fstab install_fs_tools hostname \
805      initrd grub_install passwords \
806      custom_scripts upgrade_system remove_apt_cache services \
807      remove_chrootmirror; do
808      if stage "$i" ; then
809        "$i"
810        stage "$i" 'done'
811      fi
812   done
813   # always execute the finalize stage:
814   finalize
815 # }}}
816
817 # finally exit the chroot {{{
818   echo "Finished chroot installation, exiting."
819   exit 0
820 # }}}
821
822 ## END OF FILE #################################################################
823 # vim: ai tw=80 expandtab foldmethod=marker